#!/usr/local/bin/perl
##############################################
# MeySoft Banner Manager - Version 2.5F
# Last Update: May 12, 1998
# Copyright (c) 1998 MeySoft
# Author: Jeffrey L. Meyer, Sr.Programmer
# WebMaster@MeySoft.com
#
# THIS HEADER MUST REMAIN INTACT
##############################################
require "config25.pl";
require "bm25fn.pl";
require "flush.pl";

alarm(30);
$no_error=1;
@slist=split(/,/,$CFG{'slist'});
@CTRL=();
@ACCT=();
$ext_msg="";
$sponsor=0;

if($ENV{'REQUEST_METHOD'} eq 'POST'){
  read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
}else{
 $data="$ENV{'QUERY_STRING'}";
}
 
@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
  $field_val=~ tr/+/ /;
  $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

if(($data eq 'FORM')||($data eq '')){
 &send_header("member Login"); 
 &send_form;
 exit;
}


&send_header("Members Area");

if(!$DATA{'acct_num'}){
  $ext_msg .="Missing Account Number, ";
  $no_error=0;
  &send_form;
}else{
 ($acct_num,$sf)=split(/-/,$DATA{'acct_num'});
 $style=$slist[$sf-1];
}

if(!$DATA{'password'}){
  $ext_msg .= "Missing password, ";
  $no_error=0;
 &send_form;
}else{
 $password="$DATA{'password'}";
}

if($style =~ /S/){
 $sponsor=1;
}
$dbp="$CFG{'acct_dir'}/$style";

if(&get_ctrl_data("$dbp")==0){
 print "<B><I>error</I></B><BR>\n\n";
 &send_error;
exit;
}


if($acct_num > $CTRL[2]){
  &rescan("$dbp");
}

$last=$CTRL[2];
if($acct_num > $last){
 $ext_msg .="Invalid Account number, ";
 &send_form; 
}
$tst="$style";
$tst=~ s/S//g;
($bw,$bh)=split(/x/,$tst);

if(&get_acct("$dbp","$acct_num")==0){
 &send_error;
 exit;
}

$ext=substr("$ACCT[$IMAGE]",rindex("$ACCT[$IMAGE]",".")+1);


if(&check_pw==1){
&send_it;
 exit;
}else{
 $no_error=0;
 &send_form;
 exit;
}
&send_footer;
exit;

#############################
sub send_it {
$bansshown=$ACCT[$PAIDIMP]+$ACCT[$FREEIMP];
$ext=substr($ACCT[$IMAGE],rindex($ACCT[$IMAGE],".")+1);

 $targs="$ACCT[$TARGETS]";
 $targs=~ s/\|/, /g;
 $blks="$ACCT[$BLOCKS]";
 $blks=~ s/\|/, /g;
 if($blks eq ''){
   $blks="NONE";
 }
if($CFG{'use_upload'}==1){
 $img_url="$CFG{'cgi_bin_path'}/bimage.cgi?$dbp/bans/$acct_num.$ext";
}else{
 $img_url="$ACCT[$IMAGE]";
}


print <<"PAGE";
<CENTER>
<table border=0 bgcolor="#$COLOR{'headers'}" width=600 cellpadding=5 cellspacing=0>
<TR>
<TD align=middle><font size=4 color="#$COLOR{'header_text'}">Statistics For Account No: $acct_num - $sf</font></td>
</tr>
</table>
<BR>
<table border=0 bgcolor="#$COLOR{'table_bgcolor'}" width=600 cellpadding=5 cellspacing=0>
<tr>
<td width=60% align=right><B>Account type/Status:</B></td><td>$ACCT[$TYPE]</td>
</tr>
<tr>
<td  width=60% align=right><B>Total Impressions <I>On Other Pages:</I></B></td><td>$ACCT[$CALLS]</td>
</tr>
<tr>
<td  width=60% align=right><B>Number of Click-through Hits <I>From Other Pages:</I></B></td><td>$ACCT[$HITS]</td>
</tr>
<tr>
<td  width=60% align=right><B>Banners <I>Shown on your site:</I></B></td><td>$bansshown</td>
</tr>
PAGE

if($ACCT[$CALLS] !=0){
  $ratio=($ACCT[$HITS] / $ACCT[$CALLS]) *100;
 }else{
   $ratio=0;
 }
$s_r=$ratio;
$s_ratio=substr($s_r,0,4);

print <<"PAGE";
<tr>
<td  width=60% align=right><B>Ratio of Hits to Displays:</B></td><td>$s_ratio %</td>
</tr>
<tr>
<td  width=60% align=right><B>Credits Remaining:</B></td><td>$ACCT[$CREDITS]</td>
</tr>
<TR bgcolor="#$COLOR{'bgcolor'}"><td>&nbsp</td><td>&nbsp</td></tr>
<tr>
<td colspan=2 align=middle><a href="mc.cgi?acct_num=$acct_num&style=$style&password=$DATA{'password'}"><img src="$CFG{'images'}/history.gif"></a></td>
</tr>
</table>
<BR>
<table border=0 bgcolor="#$COLOR{'table_bgcolor'}" width=600 cellpadding=5 cellspacing=0>
<tr>
<td colspan=2 align=middle><B>Start Date:</B> $ACCT[$STARTDATE]<BR><B>Last Update:</B> $ACCT[$LASTUPDATE] <B>Last Counter Reset:</B> $ACCT[$LASTRESET]</td>
</tr>
<tr bgcolor="#$COLOR{'bgcolor'}">
<td colspan=2>Your Banner:<BR><img src="$CFG{'images'}/$bw.gif">
<BR clear=all><a href="$ACCT[$LINK]"><img src="$img_url" border=1></a><img src="$CFG{'images'}/$bh.gif">
<br clear=all>
</tr>
</table>
<BR>
<table border=0 bgcolor="#$COLOR{'table_bgcolor'}" width=600 cellpadding=5 cellspacing=0>
<tr>
<td width=50% align=right><B>Your Site Category:</B></td><td>$ACCT[$SITE]</td>
</tr>
<TR>
<td width=50% valign=top align=right><B>Currently Targeted Site Categories:</B></td>
<td>$targs</td>
</tr>
<TR>
<td width=50% valign=top align=right><B>Currently Blocked Site Categories:</B></td>
<td>$blks</td>
</tr>
</table>
<BR>
<B>Use the update form below to make changes to your profile</B><HR>


<FORM METHOD="POST" ACTION="gethtml.cgi">
<input type="hidden" name="a" value="$acct_num">
<input type="hidden" name="s" value="$style">
<input type="hidden" name="password" value="$DATA{'password'}">
<input type="image" src="$CFG{'images'}/html.gif" alt="Get Your HTML Code">
</FORM>
PAGE

###################
# UPDATE FORM
print <<"FORM";
<CENTER>
<table width=600 border=0  bgcolor="#$COLOR{'headers'}" cellpadding=5 cellspacing=0>
<tr><td align=middle><font size=4 color="#$COLOR{'header_text'}">Update Profile Form</font></td>
</tr></table>
<BR>
<FORM METHOD="POST" ACTION="update.cgi">
<input type=hidden name="acct_num" value="$DATA{'acct_num'}">
<input type="hidden" name="password" value="$DATA{'password'}">
<table width=600 border=0 bgcolor="#$COLOR{'table_bgcolor'}" cellpadding=5 cellspacing=0>
<tr>
<TD colspan=2 bgcolor="#$COLOR{'headers'}" ALIGN=middle><FONT SIZE=4 COLOR="#$COLOR{'header_text'}">Your Site Information</FONT></TD>
</tr>
<TR>
<TD><font size=4>Account Number: $DATA{'acct_num'}</td><td>&nbsp</td>
</tr>
FORM

print "<tr><td align=right>Site Name</td><td align=left><INPUT TYPE=\"text\" NAME=\"name\" value=\"$ACCT[$USER]\" SIZE=40 MAXLENGTH=60></td></tr>";
print "<tr><td align=right>Email Address</td><td align=left><INPUT TYPE=\"text\" NAME=\"email\" value=\"$ACCT[$EMAIL]\" SIZE=40 MAXLENGTH=100></td></tr>";
print "<tr><td align=right>Banner Image URL</td><td align=left><INPUT TYPE=\"text\" NAME=\"bannerurl\" value=\"$ACCT[$IMAGE]\" SIZE=40 MAXLENGTH=100></td></tr>";
if($ban==1){
print "<tr><td></td><td align=left>";
print "<img src=\"$CFG{'images'}/$bw.gif\"><br clear=all><img src=\"$ACCT[$IMAGE]\" border=1 ALT=\"Your Banner Image\">";
print "<img src=\"$CFG{'images'}/$bh.gif\"><br clear=all><I>Your banner should appear above</I></td></tr>";
}
print "<tr><td align=right>Link URL</td><td align=left> <INPUT TYPE=\"text\" NAME=\"linkurl\" value=\"$ACCT[$LINK]\" SIZE=40 MAXLENGTH=100></td></tr>";
print "<input type=\"hidden\" name=\"pageurl\" value=\"N/A\">\n";

print "<BR></td></tr></table><BR>";

###########
# CATEGORY
$site="$ACCT[$SITE]";
@targets=split(/\|/,$ACCT[$TARGETS]);
@blocks=split(/\|/,$ACCT[$BLOCKS]);

if(($CFG{'use_targeting'}==1)&&($sponsor == 0)){
 print "<CENTER><table border=0 bgcolor=\"#$COLOR{'table_bgcolor'}\" cellpadding=5 cellspacing=0 WIDTH=600>";
 print "<TR><TD colspan=2 bgcolor=\"#$COLOR{'headers'}\" ALIGN=middle><FONT SIZE=4 COLOR=\"#$COLOR{'header_text'}\">Your Target Advertising</FONT></TD></tr>";
 print "<tr><td align=right><B>Select a single site category <BR>that best describes your site content</B><BR></td>";
 print "<td align=left><SELECT NAME=\"sitetype\" SIZE=1>\n";
 $site=~ s/(\n|\r)//g; 
 open(LST,"category.txt");
 while($line=<LST>){
  $line=~ s/(\n|\r)//g;
  if("$line" eq "$site"){
     print "<OPTION SELECTED>$line\n";
  }else{
     print "<OPTION>$line\n";
  }
 }
 close(LST);
 print "</SELECT></td></tr>\n";
}else{
 print "<input type=hidden name=sitetype value=\"N/A\">\n";
}
############
# TARGETS

if(($CFG{'use_targeting'}==1)&&($sponsor == 0)){
 print "<tr><td align=right><B>Select the site categories <BR>that you wish to <I>target</i> your ad to</B><BR>";
 print "<I>(Use CTRL to select/deselect<BR> multiple categories)</i></td>";
 print "<td align=left><SELECT MULTIPLE NAME=\"targets\" SIZE=5>\n";
 open(LST,"category.txt");
 while($line=<LST>){
  $line=~ s/(\n|\r)//g;
  $in_list=0;
    foreach $targ(@targets){
      $targ=~ s/(\n|\r)//g;
        if("$line" eq "$targ"){
          $in_list=1;
        }
    }
  if(($in_list==1)||($targets[0] eq 'ALL')){
     print "<OPTION SELECTED>$line\n";
  }else{
     print "<OPTION>$line\n";
  }
 }
 close(LST);
 print "</SELECT></td></tr>\n";
}else{
 print "<input type=hidden name=targets value=\"ALL\">\n";
}
############
###########
# BLOCKS

if(($CFG{'use_targeting'}==1)&&($sponsor == 0)){
 print "<tr><td align=right><B>Select the site categories that<BR> you do not want to show ads for</B><BR>";
 print "<I>(Use CTRL to select/deselect<BR> multiple categories)</i></td>";
 print "<td align=left><SELECT MULTIPLE NAME=\"blocks\" SIZE=5>\n";
 open(LST,"category.txt");
 while($line=<LST>){
  $line=~ s/(\n|\r)//g;
  $in_list=0;
    foreach $block(@blocks){
      $targ=~ s/(\n|\r)//g;
        if("$line" eq "$block"){
          $in_list=1;
        }
    }
  if($in_list==1){
     print "<OPTION SELECTED>$line\n";
  }else{
     print "<OPTION>$line\n";
  }
 }
 close(LST);
 print "</SELECT></td></tr>\n";
}else{
 print "<input type=hidden name=blocks value=\"NONE\">\n";
}
############
print <<"WEB_FORMM";
</table>
<BR>
<table border=0 bgcolor="#$COLOR{'table_bgcolor'}" cellpadding=5 cellspacing=0 WIDTH=600>
<tr>
<TD colspan=2 bgcolor="#$COLOR{'headers'}" ALIGN=middle><FONT SIZE=4 COLOR="#$COLOR{'header_text'}">New Password Selection</FONT></TD>
</tr>
<tr><td align=right><B>Select a new password</B></td>
<td align=left><INPUT TYPE="password" NAME="newpass" SIZE=20 MAXLENGTH=20> 20 characters max</td>
</tr>
<tr><td align=right><B>Verify new password</B></td>
<td align=left><INPUT TYPE="password" NAME="verify" SIZE=20 MAXLENGTH=20></td>
</tr>
</table>

<hr size=2>

<INPUT TYPE="checkbox" NAME="delete" VALUE="YES" > Delete Account 
<INPUT TYPE="checkbox" NAME="counters" VALUE="reset" > Reset Impression/Hit Counters
</td></tr></table>
<HR>
<BR>

<INPUT TYPE="image" src="$CFG{'images'}/update.gif" alt="Update">
</FORM>
<A href=\"$CFG{'banner_page'}\"><img src="$CFG{'images'}/mainpage.gif" alt="Banner Page"></a>
<a href=\"topclick.cgi?$DATA{'style'}\"><img src=\"$CFG{'images'}/click.gif\" alt=\"Top Clicks\" ></a>
</CENTER>
WEB_FORMM
 &send_footer;
 &flush(STDOUT);

if($CFG{'notify_checked'}==1){
 if($CFG{'send_env'}==0){
   &log_activity("$dbp","$DATA{'acct_num'}","STAT CHECK");
 }else{
   &log_activity("$dbp","$DATA{'acct_num'} $ENV{'REMOTE_HOST'} $ENV{'REMOTE_ADDR'}","STAT CHECK");
 }
}
exit;
}
#####################################
sub send_error {
 $ext_msg .="Error in submitting form. make sure correct data has been entered.\n";
 $ext_msg .="Error returned: $! For Account: \'$acct_num - $sf\'\n";
 &send_form;
exit;
}
########################
sub check_pw{
 $test_pw=crypt($password,substr("$CFG{'encrypt_key'}",0,2));
 if(!($test_pw eq $ACCT[$PASSW])){
 $ext_msg .= "Invalid Password, ";
 return 0;
}else{
 return 1;
}
}
############################################################
sub send_form{
print <<"WEB_FORM";
<center>
<table border=0 bgcolor="#$COLOR{'headers'}" cellpadding=5 cellspacing=0 WIDTH=600>
<TD ALIGN=middle><FONT SIZE=4 COLOR="#$COLOR{'header_text'}">Member Login</font></td>
</tr></table>
<BR>
WEB_FORM

if($no_error==0){
print <<"WEB_FORM";
<table border=3 width=400><tr><td><font color="#$COLOR{'link'}">
BOTH Account Number and Password are required, and must match original (case sensitive)<br>
$ext_msg</font>
</td>
</tr>
</table>
WEB_FORM
}

print <<"WEB_FORM";
<BR>
<FORM METHOD="POST" ACTION="mlogin.cgi">
<table border=0 bgcolor="#$COLOR{'table_bgcolor'}" cellpadding=5 cellspacing=0 width=400>
<tr><td align=right>Account number</td>
<td><INPUT TYPE="text" NAME="acct_num" value="$DATA{'acct_num'}" size=10 maxlength=20>(###-#)</td>
</tr>
<tr>
<td align=right>Password</td>
<td><INPUT TYPE="password" name="password"  value="$DATA{'password'}" size=20 maxlength=20><BR>Case Sensitive</td>
</tr></table>
<CENTER>
<BR>
<INPUT TYPE="image" src="$CFG{'images'}/login.gif" alt="Login Now">
</CENTER>
</FORM>
<CENTER>
<a href="$CFG{'banner_page'}"><img src="$CFG{'images'}/mainpage.gif" alt="Banners Page"></a>
</CENTER>
WEB_FORM
&send_footer;
exit;
}
